/*--------------------------------------------------------------------
  
  --------------------------------------------------------------------*/
#include "cblsrv.h"
#include "newport.h"



/*
 *
 */
usb78k::~usb78k() {
}
/*====================================================================
  _FlushTxBuf
  ====================================================================*/
void usb78k::FlushTxBuf(VOID) {
    DWORD  cbWrite;

    if(nTxd > 0) {
        WriteFile(hCom,bTxd,nTxd,&cbWrite,NULL);
        nTxd = 0;
    }
}
/*====================================================================
  _UpdateTxBuf
  ====================================================================*/
VOID usb78k::UpdateTxBuf(u8 txd) {
    DWORD  cbWrite;

    bTxd[nTxd++] = txd;
    if(nTxd >= MAX78K0BUFF) {
        WriteFile(hCom,bTxd,nTxd,&cbWrite,NULL);
        nTxd = 0;
    }
}
/*
 *
 */
int usb78k::open() {
    COMMTIMEOUTS  CommTimeOuts;
    char          szPort[64];

    strcat(strcpy(szPort,"\\\\.\\COM"),addr);
    hCom = CreateFile(szPort,
                      GENERIC_READ | GENERIC_WRITE,
                      0,
                      NULL,
                      OPEN_EXISTING,
                      0,
                      NULL);
    if(hCom == INVALID_HANDLE_VALUE ) {
        fprintf(stdout,"%s߰Ă݂ł܂B\n",szPort);
        return(-1);
    }
    GetCommTimeouts(hCom,&CommTimeOuts);
    CommTimeOuts.ReadTotalTimeoutMultiplier = 10;
    CommTimeOuts.ReadTotalTimeoutConstant   = 3000;
    SetCommTimeouts(hCom,&CommTimeOuts);
    pp_data = 0;
    nTxd    = 0;
    UpdateTxBuf(pp_data);
    return(0);
}
/*
 *
 */
int usb78k::close() {
    FlushTxBuf();
    CloseHandle(hCom);
    hCom = INVALID_HANDLE_VALUE;
    return(0);
}
/*
 *
 */
int usb78k::get_tdo() {
    u8     brxd;
    DWORD  cbRead;
    int    nretry = 1;
    u8     mask = get_tdo_mask();

    FlushTxBuf();
    WriteFile(hCom,&mask,sizeof(mask),&cbRead,NULL);
    for(cbRead = 0;(cbRead < sizeof(BYTE))&&(nretry);nretry--) {
        ReadFile(hCom,(LPVOID)&brxd,sizeof(BYTE),&cbRead,NULL);
    }

if(cbRead < 1) {
printf("get_tdo failed.\n");
}

    if(cbRead >= 1) {
        return((brxd & mask)?  1 : 0);
    }
    return(-1);
}
/*
 *
 */
int usb78k::set_tdi(int b) {
    int  mask = get_tdi_mask();

    if(b) {
        pp_data |= mask;
    } else {
        pp_data &= ~mask;
    }
    UpdateTxBuf(pp_data);
    return(0);
}
/*
 *
 */
int usb78k::set_tms(int b) {
    int  mask = get_tms_mask();

    if(b) {
        pp_data |= mask;
    } else {
        pp_data &= ~mask;
    }
    UpdateTxBuf(pp_data);
    return(0);
}
/*
 *
 */
int usb78k::set_tck(int b) {
    int  mask = get_tck_mask();

    if(b) {
        pp_data |= mask;
    } else {
        pp_data &= ~mask;
    }
    UpdateTxBuf(pp_data);
    return(0);
}
