/*--------------------------------------------------------------------
  
  --------------------------------------------------------------------*/
#ifndef _NEWPORTH_
#define _NEWPORTH_
#include "parport.h"

#define MAX78K0BUFF           (64*1024)



class usb78k : public parport {
public:
    usb78k(const char *addr) : parport(addr) {}
    virtual ~usb78k();

public:
    virtual int open();
    virtual int close();

    virtual int get_desc(char *desc,int len) {
        return(snprintf(desc,len,"uPD78F0730 SIE engine (%s)",addr));
    }

    virtual int get_tdo();
    virtual int set_tdi(int b);
    virtual int set_tms(int b);
    virtual int set_tck(int b);

protected:
    virtual u8 get_tck_mask() { return(0x40); }
    virtual u8 get_tms_mask() { return(0x80); }
    virtual u8 get_tdi_mask() { return(0x20); }
    virtual u8 get_tdo_mask() { return(0x04); }

protected:
    void FlushTxBuf(VOID);
    void UpdateTxBuf(u8 txd);

protected:
    HANDLE  hCom;
    int     nTxd;
    u8      bTxd[MAX78K0BUFF];
};

#endif
