#pragma sfr
#pragma di
#pragma ei
#pragma section @@CODE BIOS_PRG AT 18E8H
#pragma section @@CNST BIOS_CST AT 1600H
#include    "types.h"
#include    "userif.h"

#define CMD_MAX  16 /* R}h̍ő咷 */

/*================================================================
O[oϐ
================================================================*/

U8             rcvdLine[CMD_MAX+1]; /* MR}h */
U8             rcvdLinePoint;
U8             numOfArgs;
U16            arg1;
U16            arg2;
tstUSBSTATUS   sts;
unsigned short inttbl[14];

const char     CopyRight1[] = "(C)Copyright 2008 ";
const char     CopyRight2[] = "NEC Electronics Corporation\n";
const char     CopyRight3[] = "Tokushu Denshi Kairo Inc.\n";
const char     Title[]      = "ToragiBIOS Version 1.20A\n";
const char     MissingArgumentMessage[] = "\n܂\n";
const char     UnknownCommandMessage[] = "Unknown Command\n";
const char     AddressOutOfRangeMessage[] = "Address out of range\n";
const char     hexchar[] = {"0123456789ABCDEF"};

// u[g[_Œ`ꂽTu[`Ăяo */

__callt extern void svUSB_comportopen( void );              /*                  */
__callt extern U8   svUSB_getstatus( tstUSBSTATUS* sts );   /*                  */
__callt extern U16  svUSB_getrecvcount( void );             /*                  */
__callt extern U16  svUSB_byteread( void );                 /*                  */
__callt extern U8   svUSB_datawrite( U8 *, U8 );            /*                  */
__callt extern U8   svWriteFlashROM( U8 );                  /*                  */
__callt extern void svUSB_comportclose( void );             /*                  */

/*================================================================
gZahnrp[`̃vg^Cv錾
================================================================*/

void           biosStart(void); // gZBIOS̊Jn
void           usbSendChar(U8 c);
void           usbSendStr(PCHAR src);
U8             usbGetChar(void);
BOOL           compareCommand(char *src);
void           dump(void);
BOOL           loadHex(U16 startAddr,U16 endAddr);
void           execCommand();
U8             getTwoHexChar();
unsigned char  usbGetStatus(tstUSBSTATUS *s);
unsigned short usbGetRecvcount(void);
void           flashWrite(void);

void           itohex(U16 n, S8 b);
unsigned char  htoi(unsigned char);

/*================================================================
vO̊Jn
================================================================*/

static BOOL usb_connected(void)
{
    if((svUSB_getstatus(&sts) & 0x10) == STS_CONNECT) return TRUE;
    return FALSE;
}

unsigned char usbGetStatus(tstUSBSTATUS *s)
{
    if(!s)
    {
        // sNULLȂBIOSSTSg
        return svUSB_getstatus(&sts);
    }
    return svUSB_getstatus(s);
}

unsigned short usbGetRecvcount(void)
{
    return svUSB_getrecvcount();
}

void usbOpen(void)
{
    // łɃ|[gJĂΉȂ
    if(usb_connected()) return;

    svUSB_comportopen();
}

void usbClose(void)
{
	if(!usb_connected()) return;
    svUSB_comportclose();
}

typedef void (*TrgIntService)(void);

void registIntSrv(unsigned char id,TrgIntService func)
{
    if(id >= 15) return;
    inttbl[id] = (U16)func;
}

unsigned char flashService(unsigned char id)
{
    return svWriteFlashROM(id);
}

/* gZBIOS̃X^[g[` */
void biosStart( void )
{
    U8 rcvdPoint;
    U8 c;
    
    for(c = 0; c < 15; c ++)
    {
        inttbl[c] = 0;
    }

    PM6  = 0xfd;        /*PM61 = 0, PM60 = 1*/
    P6.1 = 0;           // LED̓_

    svUSB_comportopen();

    while ( svUSB_getstatus(&sts) == 0x10 )
    {
        /* trȁ܂ő҂ */
    }

    while(1) 
    {
        /* ^[L[܂ő҂ */
        if(usbGetChar() == '\n') break;
    }

    // Nʂ̕\
    usbSendStr(Title);
    usbSendStr(CopyRight1);
    usbSendStr(CopyRight2);
    usbSendStr(CopyRight1);
    usbSendStr(CopyRight3);

    while(1)
    {
        rcvdPoint = 0;              //obt@Zbg
        usbSendChar('>');       //͂҂

        while(1)
        {
            c = usbGetChar();
            usbSendChar(c);     //GR[
            
            P6.1 ^= 1;            // LED_ł

            if(c == '\n')           //\nMƂ
            {
                rcvdLine[rcvdPoint] = '\0';         /*Ō\0*/
                execCommand();          /*s*/
                break;
            }

            if(c == 0x03)           //CTRL+CMƂ
            {
                usbSendChar('\n');
                break;
            }

            if(c == 0x08) // obNXy[XMƂ
            {

/* ---> TNK */
if(rcvdPoint <= 0){
usbSendChar('>');       //͂҂
continue;
}
/* <--- TNK */

                usbSendStr(" \x08");
                rcvdPoint--;
            }
            else // ̑̕MƂ
            {
                rcvdLine[rcvdPoint++] = c;
            }

            rcvdPoint &= 15; // obt@ӂȂ悤
        }
    }
}

U8 usbGetChar(void)
{
    U8 c;
    while(1)
    {
		if(!usb_connected()) return '\0';
        if(svUSB_getrecvcount() == 0) continue;
        c = (U8)svUSB_byteread(); // 8bitɂ̓G[R[hĂ
        if(c == '\r') return '\n';

        if(c == 0x1A) continue; // XLbv
        if(c == '\n') continue; // XLbv
        if(c == '\0') continue; // XLbv

        return c;
    }
}

void usbSendData(unsigned char *src,unsigned short len)
{
    U8 currentLen;
    U8 stat;

    while(len)
    {
        do {
			if(!usb_connected()) return;
            svUSB_getstatus(&sts);           // Xe[^X𒲍
        } while(sts.ucStatus & STS_TXBFULL); // TXFULLȂ烋[vWAIT

        if(len > 63) currentLen = 63;
        else         currentLen = (U8)len;

        stat = svUSB_datawrite(src,currentLen);

        if(stat == 0xff) break; // p[^ُ펞

        src += stat; // ۂɑM|C^i߂
        len -= stat; // ۂɑMc炷
    }
}

void usbRecvData(unsigned char *dest,unsigned short len)
{
    U16 i;
    for( i = 0 ; i < len ; i++)
    {
        while(1)
        {
			if(!usb_connected()) return;
            if(svUSB_getrecvcount() != 0) break;
        }
        *dest++ = (unsigned char)svUSB_byteread();
    }
}

void usbSendChar(U8 c)
{
    U8 stat;

    if(c == '\n')
    {
        usbSendChar('\r');
    }

/*
    do {
        svUSB_getstatus(&sts);           // Xe[^X𒲍
    } while(sts.ucStatus & STS_TXBFULL); // TXFULLȂ烋[vWAIT
*/

    do
    {
		if(!usb_connected()) return;
        stat = svUSB_datawrite(&c,1); // 1oCgM
    } while( stat == 0 ); // MłĂȂ΍Ē
}

void usbSendStr(PCHAR src)
{
    while(*src) usbSendChar(*src++);
}

/*16iɕϊ֐
1:ϊ
2:o͂rbg(4,8,12,16)
16iɕϊꂽ񂪏o͂*/
void itohex(U16 n, S8 b)
{
    U16 w;
    S8  i;
    b -= 4;
    for(i = b;i >= 0;i -= 4)
    {
        w = n;
        w >>= i;            //irbgEVtg
        w &= 0x0f;          //E4rbg}XN
        usbSendChar(hexchar[w]);
    }
}

/*16i̕1𐮐ɕϊ֐*/
unsigned char htoi(unsigned char c)
{
    if( (c >= '0') && (c <= '9') ) return (c - '0');
    if( (c >= 'a') && (c <= 'f') ) return (c - 'a' + 10);
    if( (c >= 'A') && (c <= 'F') ) return (c - 'A' + 10);
    return 0;
}

U16 getArgment()
{
    U16 retval = 0;

    while(rcvdLine[rcvdLinePoint] == ' ') // 󔒂XLbv
    {
        rcvdLinePoint++;
    }
    if(!rcvdLine[rcvdLinePoint]) return 0; // kȂ烊^[

    // 𔭌
    numOfArgs++;
    while(1)
    {
        U8 uc;
        uc = rcvdLine[rcvdLinePoint];
        if(uc == '\0') return retval;
        if(uc == ' ') return retval;
        retval = (retval << 4) | htoi(uc);
        rcvdLinePoint++;
    }
}

/* r֐ */
BOOL compareCommand(char *src)
{
    rcvdLinePoint = 0;
    if(!*src) return FALSE; // s

    /*R}h̔r*/
    while(*src)
    {
        // v̂͗ɃkƂȂƂ
        if(rcvdLine[rcvdLinePoint++] != *src++)     //svƂ
        {
            return FALSE;
        }
    }

    numOfArgs = 0;
    arg1 = getArgment();
    arg2 = getArgment();

    return TRUE;
}

/*K؂ȃR}hs֐*/
void execCommand()
{
    if(*rcvdLine == '\0') return; // R}h

    if(compareCommand("dump"))
    {
        if(numOfArgs != 2)
        {
            usbSendStr(MissingArgumentMessage);
            return;
        }
        dump();
        return;
    }
    if(compareCommand("wr"))
    {
        if(numOfArgs != 2)
        {
            usbSendStr(MissingArgumentMessage);
            return;
        }
		if(arg1 < 0xf000)
        {
            usbSendStr(AddressOutOfRangeMessage);
            return;
        }
        *(U8 *)arg1 = (U8)arg2;
        return;
    }
    if(compareCommand("jmp"))
    {
        void (*func)();

        if(numOfArgs == 0)
        {
            usbSendStr(MissingArgumentMessage);
            return;
        }

        func = (void (*)())arg1;

        usbSendStr("\n[UvOs܂\n");
        func();
        usbSendStr("\ns\n");

        return;
    }

    if(compareCommand("flash"))
    {
        flashWrite();
        return;
    }

    if(compareCommand("load"))
    {
        loadHex(0xf000,0xf7ff); // L͈͓̔Ȃ烍[h
        return;
    }
    usbSendStr(UnknownCommandMessage);
}

/*_v֐*/
void dump() 
{
    U8 uc;
    U8 count = 0;

    while(arg2)
    {
#if 0  /* ---> TNK */
        if(svUSB_getrecvcount() != 0) break;
#else
        if(svUSB_getrecvcount() != 0) {
            usbSendChar('\n');
            break;
        }
#endif  /* <-- TNK */

        if(count == 0)
        {
            itohex(arg1,16); // AhX\
            usbSendChar(' ');
        }

        uc = *(U8 *)arg1;
        if((uc >= ' ') && (uc <= 0x7e)) rcvdLine[count] = uc;
        else                            rcvdLine[count] = '.';
        itohex(uc, 8);

        arg1++; // AhX₷
        arg2--; // 炷

        usbSendChar(' ');

        count++;

        if(!arg2) // c肪ȂȂĂ܂
        {
            while(count != 16)
            {
                usbSendStr("   ");
                rcvdLine[count++] = ' ';
            }
        }
        if(count == 16)
        {
            rcvdLine[count] = '\0';
            usbSendStr((char *)rcvdLine);
            usbSendChar('\n');
        }
        count &= 15;
    }

}

U8 getTwoHexChar()
{
    U8 uc = htoi(usbGetChar()) << 4;
    return uc | htoi(usbGetChar());
}

void flashWrite(void)
{
    U8 i;
    for(i = 0 ; i< 8; i++)
    {
        U16 start,end;
/* ---> TNK */
for(start = 0xF000,end = 1024;end != 0;start++,end--) {
    *(unsigned char *)start = 0xFF;
}
/* <--- TNK */
        start = 0x2000 + i*1024;
        end   = start + 1023;
        itohex(start,16);
        usbSendChar('-');
        itohex(end,16);
        usbSendStr(" ͈̔͂܂HEXt@C͂Ă\n");
        if(loadHex(start,end) == FALSE) break;
        svWriteFlashROM(i);
    }
}

/*[h֐*/
/*@œKς݁ */
BOOL loadHex(U16 startAddr,U16 endAddr)
{
    U16 addr;
    U8 len,sum,w;

    usbSendStr("Drop a HEX file.\n");
    while(1)
    {
        sum = 0;
        w = usbGetChar();

        if(w == ' ') continue; // s̃zCgXy[X̓XLbv
        if(w == '\n') continue; // ŝ݂̍s͋
        if(w == 0x03) return FALSE; // CTRL+Cُ͈I
        if(w != ':')
        {
            usbSendStr("error1\n");
            return FALSE;
        }
        /*oCgi[*/
        len =  getTwoHexChar();     
        sum  += len;
        
        /*AhXi[*/
        w   =  getTwoHexChar();     
        sum  +=  w;

        addr  =  w;
        addr = addr <<8;

        w    =  getTwoHexChar();        
        sum  += w;

        addr += w;

        /*ŏIf[^`FbN*/
        w   =  getTwoHexChar();     
        if(w == 1)
        {
            getTwoHexChar();// `FbNT
            usbSendStr("complete.\n");
            return TRUE;
        }

        /*̓f[^i[*/
        while(len--)
        {
            w  =  getTwoHexChar();      
            sum += w;

            /*****ɏݏ܂********/
            if((addr >= startAddr) && (addr <= endAddr))
            {
                *(unsigned char *)(addr - startAddr + 0xf000) = w;
            }
            addr++;
            /*****************************************/
        }
        /*`FbNT*/
        w  =  getTwoHexChar();
        sum += w;

        if(sum == 0)
        {
            P6.1 ^= 1;            // LED_ł
        }
        else
        {
            usbSendChar('x');
        }       
        /*s*/
        usbGetChar();
    }
    return FALSE;
}

